Index: trunk/src/VBox/Additions/common/VBoxService/VBoxService-win.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxService-win.cpp	(revision 25165)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxService-win.cpp	(revision 25166)
@@ -44,4 +44,5 @@
 };
 
+
 /**
  * @todo Format code style.
@@ -49,11 +50,11 @@
  * @todo Add event log capabilities / check return values.
  */
-DWORD VBoxServiceWinAddAceToObjectsSecurityDescriptor (LPTSTR pszObjName,
-                                                       SE_OBJECT_TYPE ObjectType,
-                                                       LPTSTR pszTrustee,
-                                                       TRUSTEE_FORM TrusteeForm,
-                                                       DWORD dwAccessRights,
-                                                       ACCESS_MODE AccessMode,
-                                                       DWORD dwInheritance)
+DWORD VBoxServiceWinAddAceToObjectsSecurityDescriptor(LPTSTR pszObjName,
+                                                      SE_OBJECT_TYPE ObjectType,
+                                                      LPTSTR pszTrustee,
+                                                      TRUSTEE_FORM TrusteeForm,
+                                                      DWORD dwAccessRights,
+                                                      ACCESS_MODE AccessMode,
+                                                      DWORD dwInheritance)
 {
     DWORD dwRes = 0;
@@ -115,5 +116,6 @@
 }
 
-BOOL VBoxServiceWinSetStatus (DWORD dwStatus, DWORD dwCheckPoint /*= 0 */)
+
+BOOL VBoxServiceWinSetStatus(DWORD dwStatus, DWORD dwCheckPoint)
 {
     if (NULL == g_hWinServiceStatus) /* Program could be in testing mode, so no service environment available. */
@@ -132,8 +134,9 @@
     ss.dwWaitHint                 = 3000;
 
-    return SetServiceStatus (g_hWinServiceStatus, &ss);
-}
-
-int VBoxServiceWinInstall ()
+    return SetServiceStatus(g_hWinServiceStatus, &ss);
+}
+
+
+int VBoxServiceWinInstall(void)
 {
     SC_HANDLE hService, hSCManager;
@@ -173,5 +176,5 @@
 }
 
-int VBoxServiceWinUninstall ()
+int VBoxServiceWinUninstall(void)
 {
     SC_HANDLE hService, hSCManager;
@@ -216,5 +219,6 @@
 }
 
-int VBoxServiceWinStart()
+
+int VBoxServiceWinStart(void)
 {
     int rc = VINF_SUCCESS;
@@ -260,5 +264,5 @@
            always starts in main thread (which causes the SCM to wait because of the non-responding
            service). */
-        VBoxServiceWinSetStatus (SERVICE_RUNNING);
+        VBoxServiceWinSetStatus (SERVICE_RUNNING, 0);
 
         /*
@@ -269,5 +273,5 @@
 
         if (RT_FAILURE(rc))
-            VBoxServiceWinSetStatus (SERVICE_STOPPED);
+            VBoxServiceWinSetStatus (SERVICE_STOPPED, 0);
     }
 
@@ -278,11 +282,12 @@
 }
 
+
 #ifdef TARGET_NT4
-VOID WINAPI VBoxServiceWinCtrlHandler (DWORD dwControl)
+VOID WINAPI VBoxServiceWinCtrlHandler(DWORD dwControl)
 #else
-DWORD WINAPI VBoxServiceWinCtrlHandler (DWORD dwControl,
-                                        DWORD dwEventType,
-                                        LPVOID lpEventData,
-                                        LPVOID lpContext)
+DWORD WINAPI VBoxServiceWinCtrlHandler(DWORD dwControl,
+                                       DWORD dwEventType,
+                                       LPVOID lpEventData,
+                                       LPVOID lpContext)
 #endif
 {
@@ -298,5 +303,5 @@
 
     case SERVICE_CONTROL_INTERROGATE:
-        VBoxServiceWinSetStatus(g_rcWinService);
+        VBoxServiceWinSetStatus(g_rcWinService, 0);
         break;
 
@@ -304,9 +309,9 @@
     case SERVICE_CONTROL_SHUTDOWN:
         {
-            VBoxServiceWinSetStatus(SERVICE_STOP_PENDING);
+            VBoxServiceWinSetStatus(SERVICE_STOP_PENDING, 0);
 
             rc = VBoxServiceStopServices();
 
-            VBoxServiceWinSetStatus(SERVICE_STOPPED);
+            VBoxServiceWinSetStatus(SERVICE_STOPPED, 0);
         }
         break;
@@ -342,5 +347,6 @@
 }
 
-void WINAPI VBoxServiceWinMain (DWORD argc, LPTSTR *argv)
+
+void WINAPI VBoxServiceWinMain(DWORD argc, LPTSTR *argv)
 {
     int rc = VINF_SUCCESS;
@@ -377,3 +383,2 @@
     }
 }
-
Index: trunk/src/VBox/Additions/common/VBoxService/VBoxServiceInternal.h
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/VBoxServiceInternal.h	(revision 25165)
+++ trunk/src/VBox/Additions/common/VBoxService/VBoxServiceInternal.h	(revision 25166)
@@ -147,5 +147,5 @@
 extern int VBoxServiceWinUninstall(void);
 /** Reports our current status to the SCM. */
-extern BOOL VBoxServiceWinSetStatus (DWORD dwStatus, DWORD dwCheckPoint = 0);
+extern BOOL VBoxServiceWinSetStatus(DWORD dwStatus, DWORD dwCheckPoint);
 #ifdef VBOX_WITH_GUEST_PROPS
 /** Detects wheter a user is logged on based on the enumerated processes. */