Index: trunk/src/VBox/HostDrivers/Support/SUPDrv.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPDrv.c	(revision 25180)
+++ trunk/src/VBox/HostDrivers/Support/SUPDrv.c	(revision 25181)
@@ -842,5 +842,4 @@
             if (pBundle->aMem[i].MemObj != NIL_RTR0MEMOBJ)
             {
-                int rc;
                 Log2(("eType=%d pvR0=%p pvR3=%p cb=%ld\n", pBundle->aMem[i].eType, RTR0MemObjAddress(pBundle->aMem[i].MemObj),
                       (void *)RTR0MemObjAddressR3(pBundle->aMem[i].MapObjR3), (long)RTR0MemObjSize(pBundle->aMem[i].MemObj)));
Index: trunk/src/VBox/HostDrivers/Support/SUPR0IdcClientStubs.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPR0IdcClientStubs.c	(revision 25180)
+++ trunk/src/VBox/HostDrivers/Support/SUPR0IdcClientStubs.c	(revision 25181)
@@ -81,6 +81,6 @@
 SUPR0DECL(void *) SUPR0ObjRegister(PSUPDRVSESSION pSession, SUPDRVOBJTYPE enmType, PFNSUPDRVDESTRUCTOR pfnDestructor, void *pvUser1, void *pvUser2)
 {
-    static DECLCALLBACKPTR(void *, s_pfn)(PSUPDRVSESSION pSession, SUPDRVOBJTYPE enmType, PFNSUPDRVDESTRUCTOR pfnDestructor, void *pvUser1, void *pvUser2);
-    DECLCALLBACKPTR(void *,          pfn)(PSUPDRVSESSION pSession, SUPDRVOBJTYPE enmType, PFNSUPDRVDESTRUCTOR pfnDestructor, void *pvUser1, void *pvUser2);
+    static DECLCALLBACKPTR(void *, s_pfn)(PSUPDRVSESSION /* pSession */, SUPDRVOBJTYPE /* enmType */, PFNSUPDRVDESTRUCTOR /* pfnDestructor */, void * /* pvUser1 */, void * /* pvUser2 */);
+    DECLCALLBACKPTR(void *,          pfn)(PSUPDRVSESSION /* pSession */, SUPDRVOBJTYPE /* enmType */, PFNSUPDRVDESTRUCTOR /* pfnDestructor */, void * /* pvUser1 */, void * /* pvUser2 */);
     pfn = s_pfn;
     if (!pfn)
@@ -98,6 +98,6 @@
 SUPR0DECL(int) SUPR0ObjAddRef(void *pvObj, PSUPDRVSESSION pSession)
 {
-    static DECLCALLBACKPTR(int, s_pfn)(void *pvObj, PSUPDRVSESSION pSession);
-    DECLCALLBACKPTR(int,          pfn)(void *pvObj, PSUPDRVSESSION pSession);
+    static DECLCALLBACKPTR(int, s_pfn)(void * /* pvObj */, PSUPDRVSESSION /* pSession */);
+    DECLCALLBACKPTR(int,          pfn)(void * /* pvObj */, PSUPDRVSESSION /* pSession */);
     pfn = s_pfn;
     if (!pfn)
@@ -115,6 +115,6 @@
 SUPR0DECL(int) SUPR0ObjRelease(void *pvObj, PSUPDRVSESSION pSession)
 {
-    static DECLCALLBACKPTR(int, s_pfn)(void *pvObj, PSUPDRVSESSION pSession);
-    DECLCALLBACKPTR(int,          pfn)(void *pvObj, PSUPDRVSESSION pSession);
+    static DECLCALLBACKPTR(int, s_pfn)(void * /* pvObj */, PSUPDRVSESSION /* pSession */);
+    DECLCALLBACKPTR(int,          pfn)(void * /* pvObj */, PSUPDRVSESSION /* pSession */);
     pfn = s_pfn;
     if (!pfn)
@@ -132,6 +132,6 @@
 SUPR0DECL(int) SUPR0ObjVerifyAccess(void *pvObj, PSUPDRVSESSION pSession, const char *pszObjName)
 {
-    static DECLCALLBACKPTR(int, s_pfn)(void *pvObj, PSUPDRVSESSION pSession, const char *pszObjName);
-    DECLCALLBACKPTR(int,          pfn)(void *pvObj, PSUPDRVSESSION pSession, const char *pszObjName);
+    static DECLCALLBACKPTR(int, s_pfn)(void * /* pvObj */, PSUPDRVSESSION /* pSession */, const char * /* pszObjName */);
+    DECLCALLBACKPTR(int,          pfn)(void * /* pvObj */, PSUPDRVSESSION /* pSession */, const char * /* pszObjName */);
     pfn = s_pfn;
     if (!pfn)
Index: trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c	(revision 25180)
+++ trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c	(revision 25181)
@@ -150,7 +150,9 @@
 static struct modlinkage g_VBoxDrvSolarisModLinkage =
 {
-    MODREV_1,               /* loadable module system revision */
-    &g_VBoxDrvSolarisModule,
-    NULL                    /* terminate array of linkage structures */
+    MODREV_1,                     /* loadable module system revision */
+    {
+        &g_VBoxDrvSolarisModule,
+        NULL                     /* terminate array of linkage structures */
+    }
 };
 
@@ -220,5 +222,5 @@
             if (RT_SUCCESS(rc))
             {
-                int rc = ddi_soft_state_init(&g_pVBoxDrvSolarisState, sizeof(vbox_devstate_t), 8);
+                rc = ddi_soft_state_init(&g_pVBoxDrvSolarisState, sizeof(vbox_devstate_t), 8);
                 if (!rc)
                 {
@@ -378,6 +380,4 @@
 static int VBoxDrvSolarisDetach(dev_info_t *pDip, ddi_detach_cmd_t enmCmd)
 {
-    int rc = VINF_SUCCESS;
-
     LogFlow((DEVICE_NAME ":VBoxDrvSolarisDetach\n"));
     switch (enmCmd)
@@ -385,8 +385,8 @@
         case DDI_DETACH:
         {
-            int instance = ddi_get_instance(pDip);
 #ifndef USE_SESSION_HASH
             ddi_remove_minor_node(pDip, NULL);
 #else
+            int instance = ddi_get_instance(pDip);
             vbox_devstate_t *pState = ddi_get_soft_state(g_pVBoxDrvSolarisState, instance);
             ddi_remove_minor_node(pDip, NULL);
@@ -512,7 +512,7 @@
 
     *pDev = makedevice(getmajor(*pDev), instance);
+#endif
 
     return VBoxSupDrvErr2SolarisErr(rc);
-#endif
 }
 
Index: trunk/src/VBox/HostDrivers/VBoxNetAdp/solaris/VBoxNetAdp-solaris.c
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetAdp/solaris/VBoxNetAdp-solaris.c	(revision 25180)
+++ trunk/src/VBox/HostDrivers/VBoxNetAdp/solaris/VBoxNetAdp-solaris.c	(revision 25181)
@@ -177,6 +177,8 @@
 {
     MODREV_1,                       /* loadable module system revision */
-    &g_VBoxNetAdpSolarisDriver,     /* adapter streams driver framework */
-    NULL                            /* terminate array of linkage structures */
+    {
+        &g_VBoxNetAdpSolarisDriver, /* adapter streams driver framework */
+        NULL                        /* terminate array of linkage structures */
+    }
 };
 
@@ -248,5 +250,4 @@
 int _fini(void)
 {
-    int rc;
     LogFlow((DEVICE_NAME ":_fini\n"));
 
@@ -367,6 +368,9 @@
             return DDI_SUCCESS;
         }
+
+        /* case DDI_PM_RESUME: */
+        default:
+            return DDI_FAILURE;
     }
-    return DDI_FAILURE;
 }
 
@@ -421,6 +425,10 @@
             return DDI_SUCCESS;
         }
+
+        /* case DDI_SUSPEND: */
+        /* case DDI_HOTPLUG_DETACH: */
+        default:
+            return DDI_FAILURE;
     }
-    return DDI_FAILURE;
 }
 
Index: trunk/src/VBox/HostDrivers/VBoxNetFlt/solaris/VBoxNetFlt-solaris.c
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetFlt/solaris/VBoxNetFlt-solaris.c	(revision 25180)
+++ trunk/src/VBox/HostDrivers/VBoxNetFlt/solaris/VBoxNetFlt-solaris.c	(revision 25181)
@@ -262,8 +262,10 @@
 static struct modlinkage g_VBoxNetFltSolarisModLinkage =
 {
-    MODREV_1,                       /* loadable module system revision */
-    &g_VBoxNetFltSolarisDriver,     /* streams driver framework */
-    &g_VBoxNetFltSolarisModule,     /* streams module framework */
-    NULL                            /* terminate array of linkage structures */
+    MODREV_1,                        /* loadable module system revision */
+    {
+        &g_VBoxNetFltSolarisDriver,  /* streams driver framework */
+        &g_VBoxNetFltSolarisModule,  /* streams module framework */
+        NULL                         /* terminate array of linkage structures */
+    }
 };
 
@@ -566,6 +568,9 @@
             return DDI_SUCCESS;
         }
-    }
-    return DDI_FAILURE;
+
+        /* case DDI_PM_RESUME: */
+        default:
+            return DDI_FAILURE;
+    }
 }
 
@@ -587,5 +592,4 @@
         case DDI_DETACH:
         {
-            int instance = ddi_get_instance(pDip);
             ddi_remove_minor_node(pDip, NULL);
             return DDI_SUCCESS;
@@ -597,6 +601,10 @@
             return DDI_SUCCESS;
         }
-    }
-    return DDI_FAILURE;
+
+        /* case DDI_PM_SUSPEND: */
+        /* case DDI_HOT_PLUG_DETACH: */
+        default:
+            return DDI_FAILURE;
+    }
 }
 
@@ -2054,5 +2062,4 @@
                      * operating on the lower stream as insertions are direct operations on the lower stream.
                      */
-                    int ret;
                     rc = strioctl(pUdp4VNode, I_PUNLINK, (intptr_t)Ip4Interface.lifr_ip_muxid, 0, K_TO_K, kcred, &ret);
                     rc2 = strioctl(pUdp4VNode, I_PUNLINK, (intptr_t)Ip4Interface.lifr_arp_muxid, 0, K_TO_K, kcred, &ret);
@@ -2254,9 +2261,7 @@
 
     int rc;
-    int rc2;
     int ret;
     ldi_ident_t DeviceIdent = ldi_ident_from_anon();
     ldi_handle_t Ip6DevHandle;
-    ldi_handle_t Udp6DevHandle;
 
     /*
@@ -2305,5 +2310,4 @@
                      * operating on the lower stream as insertions are direct operations on the lower stream.
                      */
-                    int ret;
                     rc = strioctl(pUdp6VNode, I_PUNLINK, (intptr_t)Ip6Interface.lifr_ip_muxid, 0, K_TO_K, kcred, &ret);
                     if (!rc)
@@ -2392,5 +2396,5 @@
                             }
                             else
-                                LogRel((DEVICE_NAME ":vboxNetFltSolarisAttachIp6: failed to find position. rc=%d rc2=%d\n", rc, rc2));
+                                LogRel((DEVICE_NAME ":vboxNetFltSolarisAttachIp6: failed to find position. rc=%d\n", rc));
 
                             releasef(Ip6MuxFd);
@@ -2400,8 +2404,8 @@
                     }
                     else
-                        LogRel((DEVICE_NAME ":vboxNetFltSolarisAttachIp6: failed to unlink upper stream rc=%d rc2=%d.\n", rc, rc2));
+                        LogRel((DEVICE_NAME ":vboxNetFltSolarisAttachIp6: failed to unlink upper stream rc=%d.\n", rc));
                 }
                 else
-                    LogRel((DEVICE_NAME ":vboxNetFltSolarisAttachIp6: failed to get MuxFd from MuxId. rc=%d rc2=%d\n", rc, rc2));
+                    LogRel((DEVICE_NAME ":vboxNetFltSolarisAttachIp6: failed to get MuxFd from MuxId. rc=%d\n", rc));
             }
             else
@@ -3509,5 +3513,5 @@
     {
 #ifdef VBOXNETFLT_SOLARIS_IPV6_POLLING
-        int rc = RTSemFastMutexCreate(&pThis->u.s.hPollMtx);
+        rc = RTSemFastMutexCreate(&pThis->u.s.hPollMtx);
         if (RT_SUCCESS(rc))
         {
@@ -3694,5 +3698,5 @@
                      */
                     mblk_t *pDlpiMsg;
-                    int rc = vboxNetFltSolarisRawToUnitData(pMsg, &pDlpiMsg);
+                    rc = vboxNetFltSolarisRawToUnitData(pMsg, &pDlpiMsg);
                     if (RT_SUCCESS(rc))
                     {